<?php

namespace Teknisa\FIN\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;

class Ger01600IndiceFinanceiroController{

    protected $dataSourceName = "indice";
    protected $dataSourceManager;
    protected $crudService;

    public function __construct($crudService, $dataSourceManager){
    	$this->crudService = $crudService;
    	$this->dataSourceManager = $dataSourceManager;
    }

    public function delete($request, $response){
    	$request = $this->crudService->buildDataSetIfRow($request, 'indice');
    	$rows = $request->getDataset()->getRows();
    	$condition1 = array(
    		array(
    			"columnName" =>'CDTPINDICE',
				"operator" => "=",
				"value" => $rows[0]['CDTPINDICE']		
    		),
    		array(
    			"columnName" =>'CDINDICEMF',
				"operator" => "=",
				"value" => $rows[0]['CDINDICE']
    		)
    	);
    	$condition2 = array(
    		array(
    			"columnName" =>'CDTPINDICE2',
				"operator" => "=",
				"value" => $rows[0]['CDTPINDICE']	
    		),
    		array(
    			"columnName" =>'CDINDICEMF2',
				"operator" => "=",
				"value" => $rows[0]['CDINDICE']
    		) 
    	);

    	$conditions = [$condition1, $condition2];
    	
    	foreach($conditions as $condition){
    		$filterCriteria = new FilterCriteria('paramgeral', $condition);
    		$dataSet = $this->dataSourceManager->findBy($filterCriteria);

    		if (!empty($dataSet->getRows())){
    			throw new \Exception("Indice utilizado em Parametros de Cadastro. Impossível exlcuir!", 1);
            }
        }

        $movindiceCondition = array(
            array(
                "columnName" =>'CDTPINDICE',
                "operator" => "=",
                "value" => $rows[0]['CDTPINDICE']      
            ),
            array(
                "columnName" =>'CDINDICE',
                "operator" => "=",
                "value" => $rows[0]['CDINDICE']
            ),
            array(
                 "columnName" =>'IDPERVALOR',
                "operator" => "=",
                "value" => $rows[0]['IDPERVALOR']
            )
        );
        $filterCriteria = new FilterCriteria('movindice', $movindiceCondition);
        $dataSet = $this->dataSourceManager->findBy($filterCriteria);
      
    	$this->dataSourceManager->delete($dataSet);

    	$request->getDataSet()->setDataSourceName('indice');
    	$this->crudService->delete($response, $request->getDataSet());
    }
}